if (!('Bun' in globalThis)) throw new Error('This module requires Bun');

import { IFileIO } from '../common/runtime.ts';
import { appendFile } from 'node:fs/promises';

const BunFileIO: IFileIO = {
	openFile: async (path: string): Promise<string> => {
		const file = await globalThis.Bun.file(path);
		return await file.text();
	},
	appendFile: async function (path: string, contents: string): Promise<void> {
		return await appendFile(path, contents);
	},
	saveFile: async function (path: string, contents: string): Promise<void> {
		await globalThis.Bun.write(path, contents);
		return;
	},
};

export default BunFileIO;
